// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// AddPaymentsGoal is an object representing the database table.
type AddPaymentsGoal struct {
	ID             int64      `boil:"id" json:"id" toml:"id" yaml:"id"`
	IDGold         null.Int64 `boil:"id_gold" json:"id_gold,omitempty" toml:"id_gold" yaml:"id_gold,omitempty"`
	Amount         null.Int   `boil:"amount" json:"amount,omitempty" toml:"amount" yaml:"amount,omitempty"`
	DateAddPayment null.Time  `boil:"date_add_payment" json:"date_add_payment,omitempty" toml:"date_add_payment" yaml:"date_add_payment,omitempty"`
	CreatedAt      time.Time  `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt      time.Time  `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *addPaymentsGoalR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L addPaymentsGoalL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var AddPaymentsGoalColumns = struct {
	ID             string
	IDGold         string
	Amount         string
	DateAddPayment string
	CreatedAt      string
	UpdatedAt      string
}{
	ID:             "id",
	IDGold:         "id_gold",
	Amount:         "amount",
	DateAddPayment: "date_add_payment",
	CreatedAt:      "created_at",
	UpdatedAt:      "updated_at",
}

var AddPaymentsGoalTableColumns = struct {
	ID             string
	IDGold         string
	Amount         string
	DateAddPayment string
	CreatedAt      string
	UpdatedAt      string
}{
	ID:             "add_payments_goal.id",
	IDGold:         "add_payments_goal.id_gold",
	Amount:         "add_payments_goal.amount",
	DateAddPayment: "add_payments_goal.date_add_payment",
	CreatedAt:      "add_payments_goal.created_at",
	UpdatedAt:      "add_payments_goal.updated_at",
}

// Generated where

type whereHelperint64 struct{ field string }

func (w whereHelperint64) EQ(x int64) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.EQ, x) }
func (w whereHelperint64) NEQ(x int64) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.NEQ, x) }
func (w whereHelperint64) LT(x int64) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.LT, x) }
func (w whereHelperint64) LTE(x int64) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.LTE, x) }
func (w whereHelperint64) GT(x int64) qm.QueryMod  { return qmhelper.Where(w.field, qmhelper.GT, x) }
func (w whereHelperint64) GTE(x int64) qm.QueryMod { return qmhelper.Where(w.field, qmhelper.GTE, x) }
func (w whereHelperint64) IN(slice []int64) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereIn(fmt.Sprintf("%s IN ?", w.field), values...)
}
func (w whereHelperint64) NIN(slice []int64) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereNotIn(fmt.Sprintf("%s NOT IN ?", w.field), values...)
}

type whereHelpernull_Int64 struct{ field string }

func (w whereHelpernull_Int64) EQ(x null.Int64) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, false, x)
}
func (w whereHelpernull_Int64) NEQ(x null.Int64) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, true, x)
}
func (w whereHelpernull_Int64) LT(x null.Int64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpernull_Int64) LTE(x null.Int64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpernull_Int64) GT(x null.Int64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpernull_Int64) GTE(x null.Int64) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}
func (w whereHelpernull_Int64) IN(slice []int64) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereIn(fmt.Sprintf("%s IN ?", w.field), values...)
}
func (w whereHelpernull_Int64) NIN(slice []int64) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereNotIn(fmt.Sprintf("%s NOT IN ?", w.field), values...)
}

func (w whereHelpernull_Int64) IsNull() qm.QueryMod    { return qmhelper.WhereIsNull(w.field) }
func (w whereHelpernull_Int64) IsNotNull() qm.QueryMod { return qmhelper.WhereIsNotNull(w.field) }

type whereHelpernull_Int struct{ field string }

func (w whereHelpernull_Int) EQ(x null.Int) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, false, x)
}
func (w whereHelpernull_Int) NEQ(x null.Int) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, true, x)
}
func (w whereHelpernull_Int) LT(x null.Int) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpernull_Int) LTE(x null.Int) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpernull_Int) GT(x null.Int) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpernull_Int) GTE(x null.Int) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}
func (w whereHelpernull_Int) IN(slice []int) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereIn(fmt.Sprintf("%s IN ?", w.field), values...)
}
func (w whereHelpernull_Int) NIN(slice []int) qm.QueryMod {
	values := make([]interface{}, 0, len(slice))
	for _, value := range slice {
		values = append(values, value)
	}
	return qm.WhereNotIn(fmt.Sprintf("%s NOT IN ?", w.field), values...)
}

func (w whereHelpernull_Int) IsNull() qm.QueryMod    { return qmhelper.WhereIsNull(w.field) }
func (w whereHelpernull_Int) IsNotNull() qm.QueryMod { return qmhelper.WhereIsNotNull(w.field) }

type whereHelpernull_Time struct{ field string }

func (w whereHelpernull_Time) EQ(x null.Time) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, false, x)
}
func (w whereHelpernull_Time) NEQ(x null.Time) qm.QueryMod {
	return qmhelper.WhereNullEQ(w.field, true, x)
}
func (w whereHelpernull_Time) LT(x null.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LT, x)
}
func (w whereHelpernull_Time) LTE(x null.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.LTE, x)
}
func (w whereHelpernull_Time) GT(x null.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GT, x)
}
func (w whereHelpernull_Time) GTE(x null.Time) qm.QueryMod {
	return qmhelper.Where(w.field, qmhelper.GTE, x)
}

func (w whereHelpernull_Time) IsNull() qm.QueryMod    { return qmhelper.WhereIsNull(w.field) }
func (w whereHelpernull_Time) IsNotNull() qm.QueryMod { return qmhelper.WhereIsNotNull(w.field) }

var AddPaymentsGoalWhere = struct {
	ID             whereHelperint64
	IDGold         whereHelpernull_Int64
	Amount         whereHelpernull_Int
	DateAddPayment whereHelpernull_Time
	CreatedAt      whereHelpertime_Time
	UpdatedAt      whereHelpertime_Time
}{
	ID:             whereHelperint64{field: "\"add_payments_goal\".\"id\""},
	IDGold:         whereHelpernull_Int64{field: "\"add_payments_goal\".\"id_gold\""},
	Amount:         whereHelpernull_Int{field: "\"add_payments_goal\".\"amount\""},
	DateAddPayment: whereHelpernull_Time{field: "\"add_payments_goal\".\"date_add_payment\""},
	CreatedAt:      whereHelpertime_Time{field: "\"add_payments_goal\".\"created_at\""},
	UpdatedAt:      whereHelpertime_Time{field: "\"add_payments_goal\".\"updated_at\""},
}

// AddPaymentsGoalRels is where relationship names are stored.
var AddPaymentsGoalRels = struct {
	IDGoldOrderGoal string
}{
	IDGoldOrderGoal: "IDGoldOrderGoal",
}

// addPaymentsGoalR is where relationships are stored.
type addPaymentsGoalR struct {
	IDGoldOrderGoal *OrderGoal `boil:"IDGoldOrderGoal" json:"IDGoldOrderGoal" toml:"IDGoldOrderGoal" yaml:"IDGoldOrderGoal"`
}

// NewStruct creates a new relationship struct
func (*addPaymentsGoalR) NewStruct() *addPaymentsGoalR {
	return &addPaymentsGoalR{}
}

func (r *addPaymentsGoalR) GetIDGoldOrderGoal() *OrderGoal {
	if r == nil {
		return nil
	}
	return r.IDGoldOrderGoal
}

// addPaymentsGoalL is where Load methods for each relationship are stored.
type addPaymentsGoalL struct{}

var (
	addPaymentsGoalAllColumns            = []string{"id", "id_gold", "amount", "date_add_payment", "created_at", "updated_at"}
	addPaymentsGoalColumnsWithoutDefault = []string{}
	addPaymentsGoalColumnsWithDefault    = []string{"id", "id_gold", "amount", "date_add_payment", "created_at", "updated_at"}
	addPaymentsGoalPrimaryKeyColumns     = []string{"id"}
	addPaymentsGoalGeneratedColumns      = []string{}
)

type (
	// AddPaymentsGoalSlice is an alias for a slice of pointers to AddPaymentsGoal.
	// This should almost always be used instead of []AddPaymentsGoal.
	AddPaymentsGoalSlice []*AddPaymentsGoal
	// AddPaymentsGoalHook is the signature for custom AddPaymentsGoal hook methods
	AddPaymentsGoalHook func(context.Context, boil.ContextExecutor, *AddPaymentsGoal) error

	addPaymentsGoalQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	addPaymentsGoalType                 = reflect.TypeOf(&AddPaymentsGoal{})
	addPaymentsGoalMapping              = queries.MakeStructMapping(addPaymentsGoalType)
	addPaymentsGoalPrimaryKeyMapping, _ = queries.BindMapping(addPaymentsGoalType, addPaymentsGoalMapping, addPaymentsGoalPrimaryKeyColumns)
	addPaymentsGoalInsertCacheMut       sync.RWMutex
	addPaymentsGoalInsertCache          = make(map[string]insertCache)
	addPaymentsGoalUpdateCacheMut       sync.RWMutex
	addPaymentsGoalUpdateCache          = make(map[string]updateCache)
	addPaymentsGoalUpsertCacheMut       sync.RWMutex
	addPaymentsGoalUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var addPaymentsGoalAfterSelectHooks []AddPaymentsGoalHook

var addPaymentsGoalBeforeInsertHooks []AddPaymentsGoalHook
var addPaymentsGoalAfterInsertHooks []AddPaymentsGoalHook

var addPaymentsGoalBeforeUpdateHooks []AddPaymentsGoalHook
var addPaymentsGoalAfterUpdateHooks []AddPaymentsGoalHook

var addPaymentsGoalBeforeDeleteHooks []AddPaymentsGoalHook
var addPaymentsGoalAfterDeleteHooks []AddPaymentsGoalHook

var addPaymentsGoalBeforeUpsertHooks []AddPaymentsGoalHook
var addPaymentsGoalAfterUpsertHooks []AddPaymentsGoalHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *AddPaymentsGoal) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *AddPaymentsGoal) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *AddPaymentsGoal) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *AddPaymentsGoal) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *AddPaymentsGoal) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *AddPaymentsGoal) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *AddPaymentsGoal) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *AddPaymentsGoal) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *AddPaymentsGoal) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range addPaymentsGoalAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddAddPaymentsGoalHook registers your hook function for all future operations.
func AddAddPaymentsGoalHook(hookPoint boil.HookPoint, addPaymentsGoalHook AddPaymentsGoalHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		addPaymentsGoalAfterSelectHooks = append(addPaymentsGoalAfterSelectHooks, addPaymentsGoalHook)
	case boil.BeforeInsertHook:
		addPaymentsGoalBeforeInsertHooks = append(addPaymentsGoalBeforeInsertHooks, addPaymentsGoalHook)
	case boil.AfterInsertHook:
		addPaymentsGoalAfterInsertHooks = append(addPaymentsGoalAfterInsertHooks, addPaymentsGoalHook)
	case boil.BeforeUpdateHook:
		addPaymentsGoalBeforeUpdateHooks = append(addPaymentsGoalBeforeUpdateHooks, addPaymentsGoalHook)
	case boil.AfterUpdateHook:
		addPaymentsGoalAfterUpdateHooks = append(addPaymentsGoalAfterUpdateHooks, addPaymentsGoalHook)
	case boil.BeforeDeleteHook:
		addPaymentsGoalBeforeDeleteHooks = append(addPaymentsGoalBeforeDeleteHooks, addPaymentsGoalHook)
	case boil.AfterDeleteHook:
		addPaymentsGoalAfterDeleteHooks = append(addPaymentsGoalAfterDeleteHooks, addPaymentsGoalHook)
	case boil.BeforeUpsertHook:
		addPaymentsGoalBeforeUpsertHooks = append(addPaymentsGoalBeforeUpsertHooks, addPaymentsGoalHook)
	case boil.AfterUpsertHook:
		addPaymentsGoalAfterUpsertHooks = append(addPaymentsGoalAfterUpsertHooks, addPaymentsGoalHook)
	}
}

// One returns a single addPaymentsGoal record from the query.
func (q addPaymentsGoalQuery) One(ctx context.Context, exec boil.ContextExecutor) (*AddPaymentsGoal, error) {
	o := &AddPaymentsGoal{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for add_payments_goal")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all AddPaymentsGoal records from the query.
func (q addPaymentsGoalQuery) All(ctx context.Context, exec boil.ContextExecutor) (AddPaymentsGoalSlice, error) {
	var o []*AddPaymentsGoal

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to AddPaymentsGoal slice")
	}

	if len(addPaymentsGoalAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all AddPaymentsGoal records in the query.
func (q addPaymentsGoalQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count add_payments_goal rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q addPaymentsGoalQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if add_payments_goal exists")
	}

	return count > 0, nil
}

// IDGoldOrderGoal pointed to by the foreign key.
func (o *AddPaymentsGoal) IDGoldOrderGoal(mods ...qm.QueryMod) orderGoalQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"id\" = ?", o.IDGold),
	}

	queryMods = append(queryMods, mods...)

	return OrderGoals(queryMods...)
}

// LoadIDGoldOrderGoal allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (addPaymentsGoalL) LoadIDGoldOrderGoal(ctx context.Context, e boil.ContextExecutor, singular bool, maybeAddPaymentsGoal interface{}, mods queries.Applicator) error {
	var slice []*AddPaymentsGoal
	var object *AddPaymentsGoal

	if singular {
		var ok bool
		object, ok = maybeAddPaymentsGoal.(*AddPaymentsGoal)
		if !ok {
			object = new(AddPaymentsGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeAddPaymentsGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeAddPaymentsGoal))
			}
		}
	} else {
		s, ok := maybeAddPaymentsGoal.(*[]*AddPaymentsGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeAddPaymentsGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeAddPaymentsGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &addPaymentsGoalR{}
		}
		if !queries.IsNil(object.IDGold) {
			args = append(args, object.IDGold)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &addPaymentsGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.IDGold) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.IDGold) {
				args = append(args, obj.IDGold)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`order_goal`),
		qm.WhereIn(`order_goal.id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load OrderGoal")
	}

	var resultSlice []*OrderGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice OrderGoal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for order_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_goal")
	}

	if len(orderGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.IDGoldOrderGoal = foreign
		if foreign.R == nil {
			foreign.R = &orderGoalR{}
		}
		foreign.R.IDGoldAddPaymentsGoals = append(foreign.R.IDGoldAddPaymentsGoals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.IDGold, foreign.ID) {
				local.R.IDGoldOrderGoal = foreign
				if foreign.R == nil {
					foreign.R = &orderGoalR{}
				}
				foreign.R.IDGoldAddPaymentsGoals = append(foreign.R.IDGoldAddPaymentsGoals, local)
				break
			}
		}
	}

	return nil
}

// SetIDGoldOrderGoal of the addPaymentsGoal to the related item.
// Sets o.R.IDGoldOrderGoal to related.
// Adds o to related.R.IDGoldAddPaymentsGoals.
func (o *AddPaymentsGoal) SetIDGoldOrderGoal(ctx context.Context, exec boil.ContextExecutor, insert bool, related *OrderGoal) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"add_payments_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"id_gold"}),
		strmangle.WhereClause("\"", "\"", 2, addPaymentsGoalPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.IDGold, related.ID)
	if o.R == nil {
		o.R = &addPaymentsGoalR{
			IDGoldOrderGoal: related,
		}
	} else {
		o.R.IDGoldOrderGoal = related
	}

	if related.R == nil {
		related.R = &orderGoalR{
			IDGoldAddPaymentsGoals: AddPaymentsGoalSlice{o},
		}
	} else {
		related.R.IDGoldAddPaymentsGoals = append(related.R.IDGoldAddPaymentsGoals, o)
	}

	return nil
}

// RemoveIDGoldOrderGoal relationship.
// Sets o.R.IDGoldOrderGoal to nil.
// Removes o from all passed in related items' relationships struct.
func (o *AddPaymentsGoal) RemoveIDGoldOrderGoal(ctx context.Context, exec boil.ContextExecutor, related *OrderGoal) error {
	var err error

	queries.SetScanner(&o.IDGold, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("id_gold")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.IDGoldOrderGoal = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.IDGoldAddPaymentsGoals {
		if queries.Equal(o.IDGold, ri.IDGold) {
			continue
		}

		ln := len(related.R.IDGoldAddPaymentsGoals)
		if ln > 1 && i < ln-1 {
			related.R.IDGoldAddPaymentsGoals[i] = related.R.IDGoldAddPaymentsGoals[ln-1]
		}
		related.R.IDGoldAddPaymentsGoals = related.R.IDGoldAddPaymentsGoals[:ln-1]
		break
	}
	return nil
}

// AddPaymentsGoals retrieves all the records using an executor.
func AddPaymentsGoals(mods ...qm.QueryMod) addPaymentsGoalQuery {
	mods = append(mods, qm.From("\"add_payments_goal\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"add_payments_goal\".*"})
	}

	return addPaymentsGoalQuery{q}
}

// FindAddPaymentsGoal retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindAddPaymentsGoal(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*AddPaymentsGoal, error) {
	addPaymentsGoalObj := &AddPaymentsGoal{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"add_payments_goal\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, addPaymentsGoalObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from add_payments_goal")
	}

	if err = addPaymentsGoalObj.doAfterSelectHooks(ctx, exec); err != nil {
		return addPaymentsGoalObj, err
	}

	return addPaymentsGoalObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *AddPaymentsGoal) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no add_payments_goal provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(addPaymentsGoalColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	addPaymentsGoalInsertCacheMut.RLock()
	cache, cached := addPaymentsGoalInsertCache[key]
	addPaymentsGoalInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			addPaymentsGoalAllColumns,
			addPaymentsGoalColumnsWithDefault,
			addPaymentsGoalColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(addPaymentsGoalType, addPaymentsGoalMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(addPaymentsGoalType, addPaymentsGoalMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"add_payments_goal\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"add_payments_goal\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into add_payments_goal")
	}

	if !cached {
		addPaymentsGoalInsertCacheMut.Lock()
		addPaymentsGoalInsertCache[key] = cache
		addPaymentsGoalInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the AddPaymentsGoal.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *AddPaymentsGoal) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	addPaymentsGoalUpdateCacheMut.RLock()
	cache, cached := addPaymentsGoalUpdateCache[key]
	addPaymentsGoalUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			addPaymentsGoalAllColumns,
			addPaymentsGoalPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update add_payments_goal, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"add_payments_goal\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, addPaymentsGoalPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(addPaymentsGoalType, addPaymentsGoalMapping, append(wl, addPaymentsGoalPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update add_payments_goal row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for add_payments_goal")
	}

	if !cached {
		addPaymentsGoalUpdateCacheMut.Lock()
		addPaymentsGoalUpdateCache[key] = cache
		addPaymentsGoalUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q addPaymentsGoalQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for add_payments_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for add_payments_goal")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o AddPaymentsGoalSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), addPaymentsGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"add_payments_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, addPaymentsGoalPrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in addPaymentsGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all addPaymentsGoal")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *AddPaymentsGoal) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no add_payments_goal provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(addPaymentsGoalColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	addPaymentsGoalUpsertCacheMut.RLock()
	cache, cached := addPaymentsGoalUpsertCache[key]
	addPaymentsGoalUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			addPaymentsGoalAllColumns,
			addPaymentsGoalColumnsWithDefault,
			addPaymentsGoalColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			addPaymentsGoalAllColumns,
			addPaymentsGoalPrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert add_payments_goal, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(addPaymentsGoalPrimaryKeyColumns))
			copy(conflict, addPaymentsGoalPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"add_payments_goal\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(addPaymentsGoalType, addPaymentsGoalMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(addPaymentsGoalType, addPaymentsGoalMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert add_payments_goal")
	}

	if !cached {
		addPaymentsGoalUpsertCacheMut.Lock()
		addPaymentsGoalUpsertCache[key] = cache
		addPaymentsGoalUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single AddPaymentsGoal record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *AddPaymentsGoal) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no AddPaymentsGoal provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), addPaymentsGoalPrimaryKeyMapping)
	sql := "DELETE FROM \"add_payments_goal\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from add_payments_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for add_payments_goal")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q addPaymentsGoalQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no addPaymentsGoalQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from add_payments_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for add_payments_goal")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o AddPaymentsGoalSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(addPaymentsGoalBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), addPaymentsGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"add_payments_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, addPaymentsGoalPrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from addPaymentsGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for add_payments_goal")
	}

	if len(addPaymentsGoalAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *AddPaymentsGoal) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindAddPaymentsGoal(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *AddPaymentsGoalSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := AddPaymentsGoalSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), addPaymentsGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"add_payments_goal\".* FROM \"add_payments_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, addPaymentsGoalPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in AddPaymentsGoalSlice")
	}

	*o = slice

	return nil
}

// AddPaymentsGoalExists checks if the AddPaymentsGoal row exists.
func AddPaymentsGoalExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"add_payments_goal\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if add_payments_goal exists")
	}

	return exists, nil
}

// Exists checks if the AddPaymentsGoal row exists.
func (o *AddPaymentsGoal) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return AddPaymentsGoalExists(ctx, exec, o.ID)
}
